apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ template "trackableappname" . }}-app
  labels:
    app: {{ template "appname" . }}
    track: "{{ default .Values.application.generic.track .Values.application.app.track }}"
    tier: "{{ default .Values.application.generic.tier .Values.application.app.tier }}"
    chart: "{{ .Chart.Name }}-{{ .Chart.Version | replace "+" "_" }}"
    release: {{ .Release.Name }}
    heritage: {{ .Release.Service }}
spec:
  replicas: {{ default .Values.application.generic.replicaCount .Values.application.app.replicaCount }}
  selector:
    matchLabels:
      app: {{ template "appname" . }}
      track: "{{ default .Values.application.generic.track .Values.application.app.track }}"
      tier: "{{ default .Values.application.generic.tier .Values.application.app.tier }}"
      release: {{ .Release.Name }}
  template:
    metadata:
      labels:
        app: {{ template "appname" . }}
        track: "{{ default .Values.application.generic.track .Values.application.app.track }}"
        tier: "{{ default .Values.application.generic.tier .Values.application.app.tier }}"
        release: {{ .Release.Name }}
    spec:
      imagePullSecrets:
        - name: "registry-secret"
      containers:
      - name: {{ .Chart.Name }}
        image: {{ list . "default" | include "werfimage" }}
        command: {{ toYaml .Values.application.app.command | nindent 10 }}
        imagePullPolicy: IfNotPresent
        lifecycle:
          preStop:
            exec:
              command: [ "sleep", "15" ]
        env:
        - name: APP_PORT
          value: {{ .Values.service.internalPort | quote }}
        - name: PUBLIC_URL
          value: {{ .Values.ingress.url }}
{{- range $name, $value := .Values.env }}
        - name: {{ $name }}
          value: {{ $value | quote }}
{{- end }}
{{- range $name, $value := .Values.application.app.env }}
        - name: {{ $name }}
          value: {{ $value | quote }}
{{- end }}
        ports:
        - name: "{{ .Values.service.name }}"
          containerPort: {{ .Values.service.internalPort }}
{{ default .Values.application.generic.probes .Values.application.app.probes | toYaml | indent 8 }}
        resources:
{{ default .Values.application.generic.resources .Values.application.app.resources | toYaml | indent 10 }}
